' Einfaches Wirbelwindspiel
' (c) 2005 by Andreas Meile, CH-8242 Hofen SH

DIM SpielerAuto%(1405), GegnerAuto%(1405), andMaske%(1405), pTemp%(1405)

DECLARE SUB LadeBild (dn$, f%(), ind%)

SCREEN 7, , 4
CLS
' Grafiken laden und vorbereiten
LadeBild "auto", SpielerAuto%(), 0
PUT (0, 0), SpielerAuto%, PSET
FOR y% = 0 TO 38
  FOR x% = 0 TO 65
    f% = POINT(x%, y%)
    IF f% <> 6 THEN
      ' Eigenes Auto
      PSET (x% + 66, y%), f%
      ' Violettes Gegnerauto
      IF f% = 4 OR f% = 12 THEN
        PSET (x%, y% + 39), f% + 1
      ELSE
        PSET (x%, y% + 39), f%
      END IF
    ELSE
      ' AND-Maske
      PSET (x% + 66, y% + 39), 15
    END IF
  NEXT x%
NEXT y%
GET (66, 0)-(131, 38), SpielerAuto%
GET (0, 39)-(65, 77), GegnerAuto%
GET (66, 39)-(131, 77), andMaske%

' statische Grundgrafik: Strasse, noch ohne Streifen
LINE (0, 0)-(319, 199), 2, BF
LINE (0, 40)-(319, 159), 4, BF
LINE (0, 48)-(319, 151), 8, BF
LINE (0, 97)-(319, 102), 15, BF

p! = 0!
v! = 0!
n% = 0
t0! = TIMER + 10!

' digitaler Tiefpassfilter fr butterweiches Scrolling
DIM tRoh!(63)
ts! = 0!
FOR i% = 0 TO 63
  tRoh!(i%) = TIMER - t0!
  ts! = ts! + tRoh!(i%)
NEXT i%
t! = TIMER - t0!
h% = 0
y% = 90
pGeg! = -96!

DO
  IF p! - pGeg! > 96! THEN
    ' Auto nicht mehr da => "neuer" Gegner erscheinen lassen
    pGeg! = p! + 290!
    yGeg% = 49 + CINT(INT(64! * RND))
  END IF
  tRohNeu! = TIMER - t0!
  vGeg! = v! * .7
  dt! = (64! * tRohNeu! - ts!) / 2080!
  ts! = ts! - tRoh!(h%) + tRohNeu!
  tRoh!(h%) = tRohNeu!
  h% = h% + 1 AND 63
  SCREEN , , n%, n% - 1 AND 3
  PCOPY 4, n%
  ' Strassenstellung zeichnen
  ' Streifen
  p1% = CINT(p! - 80! * INT(p! / 80!))
  FOR i% = 0 TO 4
    x% = 80 * i% - p1%
    IF x% > -40 THEN
      LINE (80 * i% - p1%, 40)-STEP(39, 7), 15, BF
      LINE (80 * i% - p1%, 97)-STEP(39, 5), 8, BF
      LINE (80 * i% - p1%, 152)-STEP(39, 7), 15, BF
    END IF
  NEXT i%
  ' Leitplanken
  p1% = 355 - CINT(p! - 360! * INT(p! / 360!))
  IF p1% > -10 AND p1% < 330 THEN
    LINE (p1%, 28)-STEP(9, 9), 15, BF
    LINE (p1%, 162)-STEP(9, 9), 15, BF
  END IF
  ' Auto des Spielers selber
  PUT (30, y%), andMaske%, AND
  PUT (30, y%), SpielerAuto%, XOR
  ' Auto des Gegners
  pEntf% = CINT(pGeg! - p!) + 30
  IF pEntf% > -66 AND pEntf% < 320 THEN
    ' Weil ein Grafik-PUT nicht abgeschnitten werden kann, muss
    ' ber eine Hilfsflche gePUTtet werden
    IF pEntf% < 0 THEN
      lCut% = -pEntf%
    ELSE
      lCut% = 0
    END IF
    IF pEntf% > 254 THEN
      rCut% = pEntf% - 254
    ELSE
      rCut% = 0
    END IF
    GET (pEntf% + lCut%, yGeg%)-(pEntf% + 65 - rCut%, yGeg% + 38), pTemp%
    PUT (lCut%, 0), pTemp%, PSET
    PUT (0, 0), andMaske%, AND
    PUT (0, 0), GegnerAuto%, XOR
    GET (lCut%, 0)-(65 - rCut%, 38), pTemp%
    PUT (pEntf% + lCut%, yGeg%), pTemp%, PSET
    ' Hilfsflche wieder ausputzen
    LINE (0, 0)-(65, 38), 2, BF
  END IF
  t$ = INKEY$
  SELECT CASE t$
  CASE CHR$(0) + "K"
    v! = v! - 3!
  CASE CHR$(0) + "M"
    v! = v! + 3!
  CASE CHR$(0) + "H"
    y% = y% - 3
  CASE CHR$(0) + "P"
    y% = y% + 3
  END SELECT
  p! = p! + v! * dt!
  pGeg! = pGeg! + vGeg! * dt!
  n% = n% + 1 AND 3
LOOP UNTIL t$ = CHR$(27)

SCREEN 0
WIDTH 80, 25

SUB LadeBild (dn$, f%(), ind%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 11&
  basOf& = CVL(INPUT$(4, 1)) + 1&  ' ab hier beginnen die Nutzdaten
  SEEK 1, 19&
  xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
  yb& = CVL(INPUT$(4, 1))
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  komp& = CVL(INPUT$(4, 1))
  IF komp& <> 0& THEN
    PRINT "Komprimierung nicht untersttzt"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  br& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
  IF bpp% = 8 THEN
    f%(ind%) = 8 * CINT(xb&)
  ELSE
    f%(ind%) = CINT(xb&)
  END IF
  f%(ind% + 1) = CINT(yb&)
  ind% = ind% + 2
  SELECT CASE bpp%
  CASE 1, 8
    IF bpp% = 1 THEN
      b% = CINT((xb& + 7&) \ 8&)
    ELSE
      b% = CINT(xb&)
    END IF
    Pu$ = ""
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x% = 1 TO b%
        Pu$ = Pu$ + INPUT$(1, 1)
        IF LEN(Pu$) = 2 THEN
          f%(ind%) = CVI(Pu$)
          ind% = ind% + 1
          Pu$ = ""
        END IF
      NEXT x%
    NEXT y&
    IF Pu$ <> "" THEN
      f%(ind%) = CVI(Pu$ + " ")
      ind% = ind% + 1
    END IF
  CASE 4
    DIM h%(3)
    FOR i% = 0 TO 3
      h%(i%) = 0
    NEXT i%
    b% = CINT(br&) \ 4
    pu1$ = SPACE$(4 * b%)
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x1% = 1 TO b%
        FOR x2% = 1 TO 4
          z% = ASC(INPUT$(1, 1))
          FOR x3% = 0 TO 3
            h%(x3%) = 4 * h%(x3%) + (z% AND 1) + (z% AND 16) \ 8
            z% = z% \ 2
          NEXT x3%
        NEXT x2%
        FOR i% = 0 TO 3
          MID$(pu1$, x1% + b% * i%) = CHR$(h%(i%))
          h%(i%) = 0
        NEXT i%
      NEXT x1%
      FOR i% = 1 TO LEN(pu1$) STEP 2
        f%(ind%) = CVI(MID$(pu1$, i%, 2))
        ind% = ind% + 1
      NEXT i%
    NEXT y&
  CASE 24
    PRINT "Echtfarb (True Color) nicht mglich"
    ERROR 5
  CASE ELSE
    PRINT "Unbekannte Bildtiefe"
    ERROR 5
  END SELECT
  CLOSE 1
END SUB

